// Copyright 2017-2025 WIT.COM Inc. All rights reserved.
// Use of this source code is governed by the GPL 3.0

package main

import (
	"go.wit.com/widget"
)

// re-draws the buttons for each of the windows
func (w *guiWidget) redoWindows(nextW int, nextH int) {
	var startW int = nextW
	var startH int = nextH

	for _, child := range w.children {
		if child.node.WidgetType != widget.Window {
			continue
		}

		child.frame = false
		child.hasTabs = false

		child.gocuiSetWH(nextW, nextH)
		child.Hide()

		child.drawView()
		sizeW := child.gocuiSize.Width()
		nextW += sizeW + 4
		child.redoWindows(startW+3, startH+2)
	}
}
